require "Warshall.rb"
require "Grammatiken.rb"
require "Automaten.rb"
									 
class Parser

	def initialize(grammar)
		@grammar = grammar	
		@start = @grammar.getStartsymbol.getName
	end

	def grammar
		@grammar
	end
	
	def addRule(rule)
		@grammar = @grammar.addRule(rule)
	end
	
	# liefert die Relation zur BEGIN Funktion zu einer Grammatik
	def BEGIN
		tmpRel = Relation.new([[]])
		@grammar.getTerminals.each_value{|i| tmpRel.addPaar!(i.to_s,i.to_s) }
		@grammar.getRules.each_value do |x| 
			if !(x.isEpsilon) then
				links = x.getSymbol 
				tmpMenge = Menge.new(x.getAlts)
				tmpMenge.each do |i| 
					tmpRel.addPaar!(links.to_s, i.getSymbols[0].to_s)
					j=0
					while ((j<i.getSymbols.length-1)and(@grammar.getEpsilonSymb.include?(i.getSymbols[j]))) do
						j+=1
						tmpRel.addPaar!(links.to_s, i.getSymbols[j].to_s ) 
					end
				end
			end
		end
	return tmpRel
	end
	
	
	# liefert die Relation zur END Funktion zu einer Grammatik
	def END
		tmpRel = Relation.new([[]])
		@grammar.getRules.each_value do |x| 
			if !(x.isEpsilon) then
				links = x.getSymbol 
				tmpMenge = Menge.new(x.getAlts)
				tmpMenge.each do |i| 
					j=i.getSymbols.length-1
					tmpRel.addPaar!(links.to_s, i.getSymbols[j].to_s)
					while ((j>0)and(@grammar.getEpsilonSymb.include?(i.getSymbols[j]))) do
						j-=1
						tmpRel.addPaar!(links.to_s, i.getSymbols[j].to_s ) 
					end
				end
			end
		end
	return tmpRel
	end
	
	def NEXT
		tmpRel = Relation.new([[]])
		@grammar.getRules.each_value do |x| 
			if !(x.isEpsilon) then
				links = x.getSymbol
				tmpMenge = Menge.new(x.getAlts)
				tmpMenge.each do |i| 
					for b in 0..(i.getSymbols.length-2)
						j=1
						while ((b+j<i.getSymbols.length)and(@grammar.getEpsilonSymb.include?(i.getSymbols[b+j]))) do
							tmpRel.addPaar!(i.getSymbols[b].to_s, i.getSymbols[b+j].to_s )
							j+=1
						end
						if (b+j<i.getSymbols.length) then tmpRel.addPaar!(i.getSymbols[b].to_s, i.getSymbols[b+1].to_s ) end
					end
				end
			end
		end
		return tmpRel
	end

	# liefert die FIRST Menge fr eine Grammatik 
	# zu einer gegebenen Zeichenkette von Nonterminalen
	def FIRST(a,b)
		addRule("S' -> "+@start+" #\n\n")
		erg = Menge.new([])
		a.each{|symb|
			erg = erg + self.BEGIN.reflexiv.transitiv.entferneNonterminale.nachfolger(symb)
			if !(@grammar.getEpsilonSymb.include?(Symb.new(symb))) then 
				return erg.copy
			end
			}
		# zur Berechnung LR_1 bentigt Rechtskontext wird vereinigt 
		# wenn alles Epsilonsymbole vorher vorhanden
		erg += b if b != nil
		return erg
	end

	# druckt wie Jaccie alle FirstSets der Grammatik aus
	def FirstSets
		 @grammar.getRules.each_value do |x| 
			links = x.getSymbol
				tmpMenge = Menge.new(x.getAlts)
				tmpMenge.each do |i| 
					puts links.to_s+" -> "+i.to_s+" "+FIRST(i,nil).to_s #delete(" ")
				end
			end
	end
	
	
	# liefert die FOLLOW Menge fr eine Grammatik 
	# zu einer gegebenen Zeichenkette von Nonterminalen
	def FOLLOW(a)
		addRule("S' -> "+@start+" #\n\n")
		erg = Menge.new([])
			erg = erg + (self.END.inv.reflexiv.transitiv.komp(self.NEXT).komp(self.BEGIN.reflexiv.transitiv)).entferneNonterminale.nachfolger(symb)
		return erg
	end

	# druckt wie Jaccie alle FollowSets der Grammatik aus
	def FollowSets
		 @grammar.getRules.each_value do |x| 
				links = x.getSymbol
				puts links.to_s+"  "+FOLLOW(links.to_s).to_s
		 end
	end


end									 
tmp1 = Grammar.new("S -> a S a \n |b S b \n |C \n\n C ->  \n\n") #Palindrom
tmp2 = Grammar.new("S -> b S d \n |b S c S d \n |a \n\n") #LR(0) Example Buch
tmp3 = Grammar.new("S -> E \n\n E -> E + Term \n |Term \n\n Term -> Term * F \n |F \n\n F -> ( E ) \n | id \n\n")
tmp4 = Grammar.new("E -> E + T \n |T \n\n T -> T * id \n |id \n\n")
#whileg= Grammar.new("AnwF ->  Anw \n | AnwF ; Anw \n\n Zahl ->  123 \n\n Anw ->  skip \n | Name := Ausdr \n | if Bed then AnwF \n |while Bed do AnwF \n\n Bed ->  true \n | false \n | Ausdr Rop Ausdr \n\n Name ->  Var1 \n\n Ausdr ->  Name \n |Zahl \n | Ausdr Op Ausdr\n\n")
#whileg= Grammar.new("AnwF ->  Anw \n | AnwF ; Anw \n\n Anw ->  skip \n | Name := Ausdr \n | if Bed then AnwF \n |while Bed do AnwF \n\n Bed ->  true \n | false \n | Ausdr Rop Ausdr \n\nAusdr ->  Name \n |Zahl \n | Ausdr Op Ausdr\n\n")
#puts LR_1.new(whileg)
#puts tmp4
#temp = Parser.new(tmp7)
puts LR_1.new(tmp1)
#puts tmp5.getTerminals
#temp.FirstSets
#puts temp.FIRST(Menge.new(["id"]),"#").array[0].class
#temp.FollowSets
#temp = NEA.new(tmp2)
#.speichern("test")
#temp = NEA.new(tmp2)
#puts temp.getStartZustand.folgeZustand(Symb.new("S"),temp.getUebergaenge)
#temp = temp.laden("test")
#temp.zustaende_each{|i| puts i.folgeZustand(Symb.new("b"),temp.getUebergaenge).class}
#puts temp
#puts tmp.getEpsilonSymb.include?(Symb.new("S"))
#puts Item.new("T -> T * id .",nil).rueck_lesen(Symb.new("id"))#.getItem.reverse

#puts LR_0.new(tmp7)
#puts "Start:",tmpdea.getStartZustand


#gets

