require "Warshall.rb"
require "Grammatiken.rb"
require "Automaten.rb"
									 
class Parser

	def initialize(grammar)
		@grammar = grammar	
#		@begin = self.BEGIN
#		@end = self.END
#		@next = self.NEXT
		
	end

	def grammar
		@grammar
	end
	
	def begin
		@begin
	end
	
	def end
		@end
	end
	
	def next
		@next
	end
	
	def addRule(rule)
		@grammar = @grammar.addRule(rule)
	end
	
	def firstHash
		erg = Hash.new
		@grammar.getRules.each_value do |x| 
			links = x.getSymbol
				tmpMenge = Menge.new(x.getAlts)
				tmpMenge.each do |i| 
					erg[links] = self.FIRST(i.to_s.delete(" "),nil)
				end
			end
		return erg
	end
	
	def followHash
		erg = Hash.new
		@grammar.getRules.each_value do |x| 
			links = x.getSymbol
				tmpMenge = Menge.new(x.getAlts)
				tmpMenge.each do |i| 
					erg[links.to_s] = self.FOLLOW(i.to_s.delete(" "))
				end
			end
		return erg
	end

	# liefert die Relation zur BEGIN Funktion zu einer Grammatik
	def BEGIN
		tmpRel = Relation.new([[]])
		@grammar.getRules.each_value do |x| 
			if !(x.isEpsilon) then
				links = x.getSymbol 
				tmpMenge = Menge.new(x.getAlts)
				tmpMenge.each do |i| 
					tmpRel.addPaar!(links.to_s, i.getSymbols[0].to_s)
					j=0
					while ((j<i.getSymbols.length-1)and(@grammar.getEpsilonSymb.include?(i.getSymbols[j]))) do
						j+=1
						tmpRel.addPaar!(links.to_s, i.getSymbols[j].to_s ) 
					end
				end
			end
		end
	return tmpRel
	end
	
	
	# liefert die Relation zur END Funktion zu einer Grammatik
	def END
		tmpRel = Relation.new([[]])
		@grammar.getRules.each_value do |x| 
			if !(x.isEpsilon) then
				links = x.getSymbol 
				tmpMenge = Menge.new(x.getAlts)
				tmpMenge.each do |i| 
					j=i.getSymbols.length-1
					tmpRel.addPaar!(links.to_s, i.getSymbols[j].to_s)
					while ((j>0)and(@grammar.getEpsilonSymb.include?(i.getSymbols[j]))) do
						j-=1
						tmpRel.addPaar!(links.to_s, i.getSymbols[j].to_s ) 
					end
				end
			end
		end
	return tmpRel
	end
	
	def NEXT
		tmpRel = Relation.new([[]])
		@grammar.getRules.each_value do |x| 
			if !(x.isEpsilon) then
				links = x.getSymbol
				tmpMenge = Menge.new(x.getAlts)
				tmpMenge.each do |i| 
					for b in 0..(i.getSymbols.length-2)
						j=1
						while ((b+j<i.getSymbols.length)and(@grammar.getEpsilonSymb.include?(i.getSymbols[b+j]))) do
							tmpRel.addPaar!(i.getSymbols[b].to_s, i.getSymbols[b+j].to_s )
							j+=1
						end
						if (b+j<i.getSymbols.length) then tmpRel.addPaar!(i.getSymbols[b].to_s, i.getSymbols[b+1].to_s ) end
					end
				end
			end
		end
		return tmpRel
	end

	# liefert die FIRST Menge fr eine Grammatik 
	# zu einer gegebenen Zeichenkette von Nonterminalen
	def FIRST(a,b)
		addRule("@ -> S #\n\n")
		erg = Menge.new([])
		for j in 0..(a.length-1) do 
			erg = erg + self.BEGIN.reflexiv.transitiv.entferneNonterminale.nachfolger(a[j,1])
			if !(@grammar.getEpsilonSymb.include?(Symb.new(a[j,1]))) then return erg end
		end
		# zur Berechnung LR_1 bentigt Rechtskontext wird vereinigt 
		# wenn alles Epsilonsymbole vorher vorhanden
		erg += b if b != nil
		return erg
	end

	# druckt wie Jaccie alle FirstSets der Grammatik aus
	def FirstSets
		 @grammar.getRules.each_value do |x| 
			links = x.getSymbol
				tmpMenge = Menge.new(x.getAlts)
				tmpMenge.each do |i| 
					puts links.to_s+" -> "+i.to_s+" "+FIRST(i.to_s.delete(" "),nil).to_s
				end
			end
	end
	
	
	# liefert die FOLLOW Menge fr eine Grammatik 
	# zu einer gegebenen Zeichenkette von Nonterminalen
	def FOLLOW(a)
		addRule("@ -> S #\n\n")
		erg = Menge.new([])
		for j in 0..(a.length-1) do 
			erg = erg + self.END.inv.reflexiv.transitiv.komp(self.NEXT).komp(self.BEGIN.reflexiv.transitiv).entferneNonterminale.nachfolger(a[j,1])
		end
		return erg
	end

	# druckt wie Jaccie alle FollowSets der Grammatik aus
	def FollowSets
		 @grammar.getRules.each_value do |x| 
				links = x.getSymbol
				puts links.to_s+"  "+FOLLOW(links.to_s).to_s
		 end
	end


end									 
#tmp = Grammar.new("S -> C C \n  |A E \n\nA -> B D \n  |S C \n\nB -> a C \n  |C S A \n\nC ->  \n\nD -> D S \n  |d \n\nE -> b E b")
#tmp2 = Grammar.new("S -> z S d \n |b S c S d \n |a \n\n")
#tmp3 = Grammar.new("S -> a S a \n |b S b \n |C \n\n C ->  \n\n")
tmp4 = Grammar.new("S -> b S d \n |b S c S d \n |a \n\n")
#puts tmp4
temp = Parser.new(tmp4)
#puts tmp4.getTerminals
#temp.FirstSets
#puts temp.FOLLOW("S")
temp.FollowSets
#temp = NEA.new(tmp2)
#.speichern("test")
#temp = NEA.new(tmp2)
#puts temp.getStartZustand.folgeZustand(Symb.new("S"),temp.getUebergaenge)
#temp = temp.laden("test")
#temp.zustaende_each{|i| puts i.folgeZustand(Symb.new("b"),temp.getUebergaenge).class}
#puts temp
#puts tmp.getEpsilonSymb.include?(Symb.new("S"))

#puts SLR_1.new(tmp3)
#puts "Start:",tmpdea.getStartZustand


#puts temp.follow

#gets

