class Elem

  def initialize(wert,nach=nil)
    @wert = wert
    @nach = nach
  end

  def cons(wert)
    Elem.new(wert,self)
  end

  def wert
    @wert
  end

  def nachfolger
    @nach
  end

  def to_s
    return "(#{@wert},nil)" if @nach == nil
    "(#{@wert},#{@nach})"
  end

  def laenge
    return 1 if @nach == nil
    1 + @nach.laenge
  end

end

##########################################

e1 = Elem.new(16)
e2 = Elem.new(23,e1)
e3 = e2.cons(30)

puts "\nVorher:  e3 => #{e3}"

daten = Marshal.dump(e3)
e3 = e1

puts "Mitte:   e3 => #{e3}"

e3 = Marshal.load(daten)

puts "Nachher: e3 => #{e3}"

File.open("e3Marshall.txt", "w") do |f|
  Marshal.dump(e3,f)
end

##########################################

class Liste

  def initialize(elems=nil)
    @elems  = elems
    @laenge = 0 if elems == nil
    @laenge = elems.laenge if elems != nil
    self
  end

  def cons(wert)
    return Liste.new(Elem.new(wert,self.elems)) if @laenge > 0
    Liste.new(Elem.new(wert,nil)) if @laenge == 0
  end

  def elems
    @elems
  end

  def length
    @laenge
  end

  def head
    return "undef" if @laenge == 0
    @elems.wert
  end

  def tail
    return "undef" if @laenge == 0
    Liste.new(@elems.nachfolger)
  end

  def append(liste)
    return Liste.new(liste.elems) if @laenge == 0
    Liste.new(self.tail.append(liste).cons(self.head).elems)
  end

  def to_s
    return "()" if @laenge == 0
    "#{@elems}"
  end

end

##########################################


l1 = Liste.new
l2 = Liste.new(e2)
l3 = Liste.new(e3)
l = l2.append(l3)
  
puts "\nVorher:  l => #{l}"

daten = Marshal.dump(l)
l = Liste.new

puts "Mitte:   l => #{l}"

l= Marshal.load(daten)

puts "Nachher: l => #{l}"

File.open("lMarshall.txt", "w") do |f|
  Marshal.dump(l,f)
end
