# Sample code from Programing Ruby, page 262, 
# modified by Lothar Schmitz
require 'tk'

class Draw
  def do_press(x, y)
    @start_x = x
    @start_y = y
    @current_line = TkcLine.new(@canvas, x, y, x, y)
  end

  def do_motion(x, y)
    @current_line.coords @start_x, @start_y, x, y
    @current_line.fill 'black'
    do_press(x,y) # neue Startwerte!
  end

  def initialize(parent)
    @canvas = TkCanvas.new(parent)
    @canvas.pack('fill' => 'both', 'expand'=>true)
    @blank = @canvas.dup
    @start_x = @start_y = 0
    @canvas.bind("1", lambda {|e| do_press(e.x, e.y)})
    @canvas.bind("B1-Motion", lambda {|x, y| do_motion(x, y)}, "%x %y")
  end
end

root = TkRoot.new { title 'Scribble' }
root.bind "Control-c", proc{root.destroy}
root.bind "Escape", proc{root.destroy}

Draw.new(root)

exit_button = 
  TkButton.new(root) do
    text 'Exit'
    pack('padx'=>10, 'pady'=>10, 'side'=>'top')
  end
exit_button.command {exit}

Tk.mainloop